package commands;
import java.io.*;
import serverClient.*;

/**
 *	The class <i>C_gameOverCommand</i> is the <i>command</i> class
 *
 *	@author Winkler
 *	This class has following dependencies
 *	<i>import java.io.*</i>
 *	<i>import serverClient.*</i>
 *	<i>import java.net.*</i>
 *	<i>import java.util.*</i>
 *	<i>import stones.*</i>
 **/
public class C_gameOverCommand implements C_Command, Serializable
{
	/**
	 *	<i>gameEnd()</i> variable is set to true and sent to the server,
	 *	to request to be dismissed
	 */
	private boolean gameEnd = true;
	
	private static final long serialVersionUID = 13L;

	/**
	 *	The empty <i>C_gameOverCommand()</i> constructor
	 */
	public C_gameOverCommand()
	{

	}

	/**
	 *	The <i>toString()</i> method can be called by the server or client
	 *	and always returns the same value
	 *	@return "C_gameOverCommand"
	 */
	public String toString()
	{
		return "C_gameOverCommand";
	}

	/**
	 *
	 *	@param s	SEE:S_fromClient
	 */
	public void execute(S_fromClient s)
	{
		s.setGameOver();

		for(int j=0; j<s.commonThings.numberOfClients; j++)
		{
			if(S_common.gameStates[j].compareTo("") == 0)
			{
				gameEnd = false;
				break;
			}
		}

		if(gameEnd)
		{
			s.commonThings.ticker.setI(0);
		}
	}
}

