package commands;
import java.io.*;
import serverClient.*;



/**
 *	The class <i>S_printScoreCommand</i> is the <i>command</i> class
 *	that the server uses to administrate and distribute the scores.
 *	@author Winkler

 **/
public class S_printScoreCommand implements S_Command, Serializable
{

	private String[] tempPlayerNames;
	private int[] tempPlayerScores;
	private String[] tempGameStates;
	
	private static final long serialVersionUID = 13L;

	/**
	 *	<i>S_printScoreCommand()</i> constructor
	 *	@param tempPlayerNames	array for sorting
	 *	@param tempPlayerScores	scores
	 *	@param tempGameStates
	 */
	public S_printScoreCommand(String[] tempPlayerNames, int[] tempPlayerScores, String[] tempGameStates)
	{
		this.tempPlayerNames = new String[tempPlayerNames.length];
		this.tempPlayerScores = new int [tempPlayerScores.length];
		this.tempGameStates = new String[tempGameStates.length];
		for(int i = 0; i < tempPlayerScores.length; i++)
		{
			this.tempPlayerNames[i] = tempPlayerNames[i];
			this.tempPlayerScores[i] = tempPlayerScores[i];
			this.tempGameStates[i] = tempGameStates[i];

		}
	}

	/**
	 *	The <i>toString()</i> method can be called by the server or client
	 *	and always returns the same value
	 *	@return "S_printScoreCommand"
	 */
	public String toString()
	{
		return "S_printScoreCommand";
	}
	/**
	 *	The <i>execute(Client_fromServer c)</i> method is called by
	 *	the client and prints the udated scores onto the board
	 *	@param c	SEE:Client_fromServer
	 */
	public void execute(Client_fromServer c)
	{
		String output = "<html>";
		for(int i = 0; i<tempPlayerScores.length; i++)
		{
			output = output + tempPlayerNames[i] + ": " + tempPlayerScores[i]+ " " +tempGameStates[i] +"<br>";
		}
		output = output + "</html>";
		c.setPartPlayer(output);
	}

}

