package serverClient;
import java.io.*;
import commands.*;

/**
 * This thread on server-side is supervising the input stream of the server socket and processing the incoming tasks.
 * @author Winkler
 * @version 1.0
 */

public class S_fromClient extends Thread
{
	private ObjectInputStream objectInput;
	private S_toClient fredi;
	public int idi;
	private String playerName;
	public S_common commonThings;
	//public HighScore hs;

	//dieserthread wird von S_toClient gestartet mit diesen referenzen...
	public S_fromClient(ObjectInputStream input, S_toClient fred,int id, S_common commonThings)
	{
		idi = id;
		objectInput = input;
		fredi =fred;
		this.commonThings = commonThings;
	}

	/**
	 *  This method has the purpose to read and save the playernames,
	 *  read and execute commands, that the client sends,
	 *  and check if the game ended for all players when a player disconnects.
	 *  Then it kills itself and Thread that is responsable to send to the clients.
	 */

	public void run()
	{
		Object clientInput;

		try
		{
			//das erste was der Client schickt, ist sein Playername
			playerName = (String)objectInput.readObject();
			//dieser wird an den entsprechenden Stellen in Spielernamenreihung eingetragen
			S_common.playerNames[idi - 1] = playerName;
			S_common.tempPlayerNames[idi - 1] = playerName;

			//wenn der letzte (erwartete) Spieler sich verbunden hat...
			if (idi == commonThings.numberOfClients){
				//...wird eine Liste mit den Spielernamen auf der Konsole...
				System.out.println("\nActual List of Players:");
				for (int n = 0; n<commonThings.numberOfClients; n++)
				{
					System.out.println(S_common.playerNames[n]);
				}
				//...und bei den Clients ausgegeben.
				commonThings.newScore = 1;
			}

			//flag zum Beenden des Threads
			boolean kill = false;
			while(!kill)
			{
				//in clientInput steht das object das vom ObjectInputStream gelesen wurde
				clientInput = objectInput.readObject();
				//die Clients schicken nur Commandos, welche hier ausgefuehrt werden
				C_Command com = (C_Command)clientInput;
				com.execute(this);

			}
		}
		catch(Exception e)
		{
			//...bricht die Verbindung ab, wird der Spieler wird auf disconnected gesetzt...
			S_common.gameStates[idi-1] = "Disconnected";
			//...Spielende?
			boolean gameEnd = true;
			//...schaue bei den anderen Clients nach...
			for(int j=0; j<commonThings.numberOfClients; j++)
			{
				//...wenn noch einer am Spielen ist, dann...
				if(S_common.gameStates[j].compareTo("") == 0)
				{
					//...geht es weiter
					gameEnd = false;
					break;
				}
			}
			//wenn alle Game Over oder disconnected sind...
			if(gameEnd)
			{
				//...setze die Spieluhr auf 0
				commonThings.ticker.setI(0);
				System.out.print(">>> Game End <<<\n");
			}


		}
		//beende den Thread der fuer's Senden an den Client zustaendig war
		fredi.kill = true;
	}

	/**
	 *  This method is called on by a command object
	 *  and sets a flag in the sending S_toClient class in such a way, that only the stone-requesting player gets a new stone.
	 */
	public void setSendStone()
	{
		//...setzt eine Flag welche einen Spielstein zum versenden freigibt (die Flag wird nach dem Versenden in der Klasse S_toClient wieder auf false gesetzt)
		//damit NUR der Client, der den Stein angefordert hat ihn auch bekommt, wird die Flag gleich der ID gesetzt.
		//fredi.sendStone = idi;

		commonThings.setNewStonesFlag();
	}

	/**
	 *  This method is called on by a command object, refreshes the score of a player and sorts the player arrays by the new scores.
	 *  @param score is the new score that a player sends in a command object, every time he gets a line.
	 */
	public void setScore(int score)
	{
		//der Punktestand von dem jeweiligen Spieler wird erneuert
		S_common.playerScores[idi-1] = score;

		//jetzt muss alles wieder nach den neuen Punktestaenden sortiert werden
		//commonThings.sortScores();

		//sort and send the new scores
		commonThings.setNewScoreFlag();
		//auf der Serverkonsole werden die neuen Punktstaende auch noch ausgegeben
		//System.out.println("New Score:");
		for(int i = 0; i<commonThings.numberOfClients; i++)
		{
			System.out.println(S_common.tempPlayerNames[i] + ": " + S_common.tempPlayerScores[i]);
		}
	}
	/**
	 *  This method is called on by a command object and sets a player game over.
	 */
	public void setGameOver()
	{
		//der Spieler traegt sich selbst als Game Over in die Spielstadienreihung ein
		S_common.gameStates[idi-1] = "Game Over";

		//setScoreList();
	}

	public void setScoreList()
	{
		//bestscoreliste wird hier erstellt
		//String cScore = "" + S_common.playerScores[idi-1];
		//String cName = S_common.playerNames[idi-1];


		/*
		//zugriff auf bestenliste
		HighScore hs = new HighScore();
		hs.setHS(cName, cScore);
		 */
	}
}
